#include <unistd.h>

#include <stdio.h>

#include <hipc/posix/clientutils.h>
#include <hipc/session.h>

#include "CFGled.h"
#include "CFGled_ccfg.h"

int main(void)
{
    hipc_session sess;
    struct STRUprm prm;
    int fdr = STDIN_FILENO;
    int fdw = STDOUT_FILENO;

    hipcOpen(&sess, &HIPCUD_CFGled_CCFG,
             hipcPosixReadMsg, &fdr, hipcPosixWriteMsg, &fdw);
    HIPC_ERRCHECK(&sess);

    hipcGet(&sess, "STRUprm.led", &prm);
    HIPC_ERRCHECK(&sess);
    fprintf(stderr, "STRUprm.led: %d\n", prm.led);

    prm.led = 1;
    hipcPut(&sess, "STRUprm.led", &prm);
    HIPC_ERRCHECK(&sess);

    hipcClose(&sess);
    HIPC_ERRCHECK(&sess);
    fprintf(stderr, "end\n");

    return 0;
}
