#include <unistd.h>

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include <hipc/posix/clientutils.h>
#include <hipc/session.h>

#include "CFGrt.h"
#include "CFGrt_ccfg.h"

enum HIPC_errno handler_log(struct HIPC_client *cl_p, const hipc_msg msg,
                            void *cimg, void *arg)
{
    struct STRUlog *log_p;
    FILE *fp;

    assert(NULL != cimg);
    assert(NULL != arg);
    log_p = cimg;
    fp = arg;

    fprintf(fp, "tick/out %5d/%d\n", log_p->tick, log_p->output);

    return HIPC_SUCCESS;
}

int main(void)
{
    struct STRUprm data[] = {
        {4, {1, 1, 1, 0}},
        {3, {1, 1, 0}},
        {2, {1, 0}},
        {0},
    };
    struct STRUlog log;
    FILE *fp;
    hipc_session sess;
    int fdr = STDIN_FILENO;
    int fdw = STDOUT_FILENO;
    int i;

    fp = fopen("log.txt", "w");
    if (NULL == fp) {
        perror("log.txt");
        exit(EXIT_FAILURE);
    }

    hipcOpen(&sess, &HIPCUD_CFGrt_CCFG,
             hipcPosixReadMsg, &fdr, hipcPosixWriteMsg, &fdw);
    HIPC_ERRCHECK(&sess);

    hipcSetHandler(&sess, "STRUlog", &log, handler_log, fp);
    HIPC_ERRCHECK(&sess);

    for (i = 0; i < sizeof(data) / sizeof(data[0]); ++i) {
        hipcPut(&sess, "STRUprm", &data[i]);
        HIPC_ERRCHECK(&sess);
    }

    hipcClose(&sess);
    HIPC_ERRCHECK(&sess);

    fclose(fp);

    fprintf(stderr, "end\n");

    return 0;
}
