#include <unistd.h>

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#include <hipc/posix/ioutils.h>
#include <hipc/posix/usoc.h>

#include "CFGrt.h"
#include "hipcsvs_rt.h"

static void *runMockServer(void *arg)
{
    struct HIPC_pbank *const pbank_p = &hipcsvsRt_pbank;
    struct STRUprm const *prm_p;

    for (;;) {
        hipcPbankSwitchAccept(pbank_p);
        prm_p = hipcPbankGetReadOnlyPage(pbank_p);
        fprintf(stderr, "led:%d\n", prm_p->led);
        usleep(1000 * 1000);
    }

    pthread_exit(NULL);
}

int main(void)
{
    pthread_attr_t attr;
    pthread_t thread;
    struct HIPC_usoc usoc;

    hipcPosixUsocInit(&usoc, STDIN_FILENO, STDOUT_FILENO);
    hipcsvsRtInit();

    if (0 != pthread_attr_init(&attr)) {
        perror("pthread_attr_init faild");
        exit(EXIT_FAILURE);
    }
    if (0 != pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED)) {
        perror("pthread_attr_setdetachstate faild");
        exit(EXIT_FAILURE);
    }
    if (0 != pthread_create(&thread, &attr, runMockServer, NULL)) {
        perror("pthread_create faild");
        exit(EXIT_FAILURE);
    }
    if (0 != pthread_attr_destroy(&attr)) {
        perror("pthread_attr_destroy faild");
        exit(EXIT_FAILURE);
    }

    hipcMain(&usoc);

    if (0 != errno) {
        perror("Error message from perror()");
        fprintf(stderr, "errno: %d\n", errno);
    }
    fprintf(stderr, "end\n");

    return 0;
}
