#ifndef HIPC_MSG_H
#define HIPC_MSG_H

#include <stddef.h>

#include <hipc.h>

typedef unsigned char hipc_msg[HIPC_MSG_ALLOCSIZE];

/**
 * Returns a pointer to the body of a HIPC message.
 *
 * @param msg HIPC message
 * @returns pointer to the body of the HIPC message.
 */
#define hipcMsgBdyP(msg) (&(msg)[HIPC_MSGHDR_SIZE])

#ifdef __cplusplus
extern "C" {
#endif

    extern size_t hipcMsgTotalSize(const hipc_msg msg);
    extern unsigned char hipcMsgBdySize(const hipc_msg msg);
    extern const void *hipcMsgBdyPtr(const hipc_msg msg);
    extern unsigned char hipcMsgType(const hipc_msg msg);
    extern unsigned char hipcMsgOffset(const hipc_msg msg);
    extern unsigned char hipcMsgStruno(const hipc_msg msg);
    extern unsigned char hipcMsgRngsize(const hipc_msg msg);

#ifdef __cplusplus
}
#endif
#endif
