#ifndef HIPC_USOC_H
#define HIPC_USOC_H

#include <stddef.h>

#include <hipc.h>

struct HIPC_usoc;

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Reads exactly \c size bytes from \c so_p.
 *
 * @param so_p Pointer to a universal socket
 * @param buf Buffer into which bytes are read
 * @param size Number of bytes to be read
 * @returns HIPC_SUCCESS on success, or an error on failure.
 */
    enum HIPC_errno
     hipcUsocRead(struct HIPC_usoc *so_p, void *buf, const size_t size);
/**
 * Writes exactly \c size bytes to \c so_p.
 *
 * @param so_p Pointer to a universal socket
 * @param buf Buffer from which bytes are written
 * @param size Number of bytes to be written
 * @returns HIPC_SUCCESS on success, or an error on failure.
 */
    enum HIPC_errno
     hipcUsocWrite(struct HIPC_usoc *so_p, const void *buf,
                   const size_t size);

#ifdef __cplusplus
}
#endif
#endif
