#include <hipc.h>

enum MOCK_errno {
    MOCK_SUCESS,
    MOCK_ERR_OVERRUN,
    MOCK_ERR_OPCODE,
    MOCK_ERR_SIZE,
    MOCK_ERR_DATA,
    MOCK_N_ERR
};

struct MockIOOp {
    int code;                   /* 0: read, 1: write */
    enum HIPC_errno retval;
    size_t size;
    unsigned char data[HIPC_IMG_ALLOCSIZE];
};

struct MockIO {
    enum MOCK_errno mock_errno;
    unsigned int i;
    unsigned int nops;
    const struct MockIOOp *ops;
};

extern void mockIOInit(struct MockIO *mio_p, const struct MockIOOp *ops,
                       const unsigned int nops);
extern int mockIOCheckCompletion(struct MockIO *mio_p);
extern enum HIPC_errno mockIORead(struct MockIO *mio_p, void *buf,
                                  const size_t size);
extern enum HIPC_errno mockIOWrite(struct MockIO *mio_p, const void *buf,
                                   const size_t size);
