#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <hipc/session.h>

int main(int argc, char *argv[])
{
    hipc_session clio;

    if (2 != argc) {
        fprintf(stderr, "Usage: %s test_id\n", argv[0]);
        exit(EXIT_FAILURE);
    }

    clio.cl.std_errno = 0;
    clio.cl.hipc_errno = HIPC_SUCCESS;
    clio.cl.err_detail_str[0] = '\0';

    switch (argv[1][0]) {
    case 'a':
        HIPC_ERRCHECK(&clio);
        break;
    case 'b':
        clio.cl.hipc_errno = HIPC_ERR_INV_ID_STR;
        HIPC_ERRCHECK(&clio);
        break;
    case 'c':
        clio.cl.hipc_errno = HIPC_N_ERR;
        HIPC_ERRCHECK(&clio);
        break;
    case 'd':
        clio.cl.hipc_errno = HIPC_ERR_INV_ID_STR;
        strcpy(clio.cl.err_detail_str, "Mock error by test_client_err");
        HIPC_ERRCHECK(&clio);
        break;
    case 'e':
        clio.cl.hipc_errno = HIPC_ERR_C_STD;
        clio.cl.std_errno = 1;
        HIPC_ERRCHECK(&clio);
        break;
    case 'f':
        HIPC_ERRCHECK(NULL);
        break;
    default:
        fprintf(stderr, "Invalid test_id: %s \n", argv[1]);
        exit(EXIT_FAILURE);
    }

    return 0;
}
